/* serializer.c generated by valac 0.56.18, the Vala compiler
 * generated from serializer.vala, do not modify */

/*
 * Copyright (C) 2010 Robin Sonefors
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "calculator.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <langinfo.h>
#include "mpfr.h"
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERIALIZER_0_PROPERTY,
	SERIALIZER_ERROR_PROPERTY,
	SERIALIZER_NUM_PROPERTIES
};
static GParamSpec* serializer_properties[SERIALIZER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _SerializerPrivate {
	gint leading_digits;
	gint trailing_digits;
	DisplayFormat format;
	gboolean show_tsep;
	gboolean show_zeroes;
	gint number_base;
	guint representation_base;
	gunichar radix;
	gunichar tsep;
	gint tsep_count;
	gchar* zero_string;
	gchar* _error;
};

static gint Serializer_private_offset;
static gpointer serializer_parent_class = NULL;

static void serializer_update_zero_string (Serializer* self);
static gchar* serializer_cast_to_string (Serializer* self,
                                  Number* x,
                                  gint* n_digits);
static gchar* serializer_cast_to_exponential_string (Serializer* self,
                                              Number* x,
                                              gboolean eng_format,
                                              gint* n_digits);
static void serializer_cast_to_string_real (Serializer* self,
                                     Number* x,
                                     gint number_base,
                                     gboolean force_sign,
                                     gint* n_digits,
                                     GString* string);
static gint serializer_cast_to_exponential_string_real (Serializer* self,
                                                 Number* x,
                                                 GString* string,
                                                 gboolean eng_format,
                                                 gint* n_digits);
static void serializer_append_exponent (Serializer* self,
                                 GString* string,
                                 gint exponent);
static void serializer_finalize (GObject * obj);
static GType serializer_get_type_once (void);
static void _vala_serializer_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_serializer_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static GType
display_format_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_FORMAT_AUTOMATIC, "DISPLAY_FORMAT_AUTOMATIC", "automatic"}, {DISPLAY_FORMAT_FIXED, "DISPLAY_FORMAT_FIXED", "fixed"}, {DISPLAY_FORMAT_SCIENTIFIC, "DISPLAY_FORMAT_SCIENTIFIC", "scientific"}, {DISPLAY_FORMAT_ENGINEERING, "DISPLAY_FORMAT_ENGINEERING", "engineering"}, {0, NULL, NULL}};
	GType display_format_type_id;
	display_format_type_id = g_enum_register_static ("DisplayFormat", values);
	return display_format_type_id;
}

GType
display_format_get_type (void)
{
	static volatile gsize display_format_type_id__once = 0;
	if (g_once_init_enter (&display_format_type_id__once)) {
		GType display_format_type_id;
		display_format_type_id = display_format_get_type_once ();
		g_once_init_leave (&display_format_type_id__once, display_format_type_id);
	}
	return display_format_type_id__once;
}

static inline gpointer
serializer_get_instance_private (Serializer* self)
{
	return G_STRUCT_MEMBER_P (self, Serializer_private_offset);
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 134 "serializer.c"
}

Serializer*
serializer_construct (GType object_type,
                      DisplayFormat format,
                      gint number_base,
                      gint trailing_digits)
{
	Serializer * self = NULL;
	gchar* radix_string = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* tsep_string = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
#line 39 "../lib/serializer.vala"
	self = (Serializer*) g_object_new (object_type, NULL);
#line 41 "../lib/serializer.vala"
	_tmp0_ = nl_langinfo (RADIXCHAR);
#line 41 "../lib/serializer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 41 "../lib/serializer.vala"
	radix_string = _tmp1_;
#line 42 "../lib/serializer.vala"
	_tmp3_ = radix_string;
#line 42 "../lib/serializer.vala"
	if (_tmp3_ != NULL) {
#line 166 "serializer.c"
		const gchar* _tmp4_;
#line 42 "../lib/serializer.vala"
		_tmp4_ = radix_string;
#line 42 "../lib/serializer.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 172 "serializer.c"
	} else {
#line 42 "../lib/serializer.vala"
		_tmp2_ = FALSE;
#line 176 "serializer.c"
	}
#line 42 "../lib/serializer.vala"
	if (_tmp2_) {
#line 180 "serializer.c"
		gchar* radix_utf8 = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 43 "../lib/serializer.vala"
		_tmp5_ = radix_string;
#line 43 "../lib/serializer.vala"
		_tmp6_ = g_locale_to_utf8 (_tmp5_, (gssize) -1, NULL, NULL, NULL);
#line 43 "../lib/serializer.vala"
		radix_utf8 = _tmp6_;
#line 44 "../lib/serializer.vala"
		_tmp7_ = radix_utf8;
#line 44 "../lib/serializer.vala"
		if (_tmp7_ != NULL) {
#line 195 "serializer.c"
			const gchar* _tmp8_;
#line 45 "../lib/serializer.vala"
			_tmp8_ = radix_utf8;
#line 45 "../lib/serializer.vala"
			self->priv->radix = string_get_char (_tmp8_, (glong) 0);
#line 201 "serializer.c"
		} else {
#line 47 "../lib/serializer.vala"
			self->priv->radix = (gunichar) '.';
#line 205 "serializer.c"
		}
#line 42 "../lib/serializer.vala"
		_g_free0 (radix_utf8);
#line 209 "serializer.c"
	} else {
#line 50 "../lib/serializer.vala"
		self->priv->radix = (gunichar) '.';
#line 213 "serializer.c"
	}
#line 51 "../lib/serializer.vala"
	_tmp9_ = nl_langinfo (THOUSEP);
#line 51 "../lib/serializer.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 51 "../lib/serializer.vala"
	tsep_string = _tmp10_;
#line 52 "../lib/serializer.vala"
	_tmp12_ = tsep_string;
#line 52 "../lib/serializer.vala"
	if (_tmp12_ != NULL) {
#line 225 "serializer.c"
		const gchar* _tmp13_;
#line 52 "../lib/serializer.vala"
		_tmp13_ = tsep_string;
#line 52 "../lib/serializer.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "") != 0;
#line 231 "serializer.c"
	} else {
#line 52 "../lib/serializer.vala"
		_tmp11_ = FALSE;
#line 235 "serializer.c"
	}
#line 52 "../lib/serializer.vala"
	if (_tmp11_) {
#line 239 "serializer.c"
		gchar* tsep_utf8 = NULL;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
#line 53 "../lib/serializer.vala"
		_tmp14_ = tsep_string;
#line 53 "../lib/serializer.vala"
		_tmp15_ = g_locale_to_utf8 (_tmp14_, (gssize) -1, NULL, NULL, NULL);
#line 53 "../lib/serializer.vala"
		tsep_utf8 = _tmp15_;
#line 54 "../lib/serializer.vala"
		_tmp16_ = tsep_utf8;
#line 54 "../lib/serializer.vala"
		if (_tmp16_ != NULL) {
#line 254 "serializer.c"
			const gchar* _tmp17_;
#line 55 "../lib/serializer.vala"
			_tmp17_ = tsep_utf8;
#line 55 "../lib/serializer.vala"
			self->priv->tsep = string_get_char (_tmp17_, (glong) 0);
#line 260 "serializer.c"
		} else {
#line 57 "../lib/serializer.vala"
			self->priv->tsep = (gunichar) ' ';
#line 264 "serializer.c"
		}
#line 52 "../lib/serializer.vala"
		_g_free0 (tsep_utf8);
#line 268 "serializer.c"
	} else {
#line 60 "../lib/serializer.vala"
		self->priv->tsep = (gunichar) ' ';
#line 272 "serializer.c"
	}
#line 61 "../lib/serializer.vala"
	self->priv->tsep_count = 3;
#line 63 "../lib/serializer.vala"
	self->priv->number_base = number_base;
#line 64 "../lib/serializer.vala"
	self->priv->representation_base = (guint) number_base;
#line 65 "../lib/serializer.vala"
	self->priv->leading_digits = 12;
#line 66 "../lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 67 "../lib/serializer.vala"
	self->priv->show_zeroes = FALSE;
#line 68 "../lib/serializer.vala"
	self->priv->show_tsep = FALSE;
#line 69 "../lib/serializer.vala"
	self->priv->format = format;
#line 70 "../lib/serializer.vala"
	serializer_update_zero_string (self);
#line 39 "../lib/serializer.vala"
	_g_free0 (tsep_string);
#line 39 "../lib/serializer.vala"
	_g_free0 (radix_string);
#line 39 "../lib/serializer.vala"
	return self;
#line 298 "serializer.c"
}

Serializer*
serializer_new (DisplayFormat format,
                gint number_base,
                gint trailing_digits)
{
#line 39 "../lib/serializer.vala"
	return serializer_construct (TYPE_SERIALIZER, format, number_base, trailing_digits);
#line 308 "serializer.c"
}

gchar*
serializer_to_string (Serializer* self,
                      Number* x)
{
	gchar* result;
#line 73 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 76 "../lib/serializer.vala"
	if (self->priv->representation_base != ((guint) self->priv->number_base)) {
#line 322 "serializer.c"
		gint n_digits = 0;
		gchar* _tmp0_;
#line 78 "../lib/serializer.vala"
		n_digits = 0;
#line 79 "../lib/serializer.vala"
		_tmp0_ = serializer_cast_to_string (self, x, &n_digits);
#line 79 "../lib/serializer.vala"
		result = _tmp0_;
#line 79 "../lib/serializer.vala"
		return result;
#line 333 "serializer.c"
	}
#line 81 "../lib/serializer.vala"
	switch (self->priv->format) {
#line 337 "serializer.c"
		default:
#line 81 "../lib/serializer.vala"
		case DISPLAY_FORMAT_AUTOMATIC:
#line 341 "serializer.c"
		{
			gint n_digits = 0;
			gchar* s0 = NULL;
			gchar* _tmp1_;
#line 85 "../lib/serializer.vala"
			n_digits = 0;
#line 86 "../lib/serializer.vala"
			_tmp1_ = serializer_cast_to_string (self, x, &n_digits);
#line 86 "../lib/serializer.vala"
			s0 = _tmp1_;
#line 88 "../lib/serializer.vala"
			switch (serializer_get_base (self)) {
#line 88 "../lib/serializer.vala"
				case 2:
#line 356 "serializer.c"
				{
					gboolean _tmp2_ = FALSE;
#line 92 "../lib/serializer.vala"
					if (n_digits <= 64) {
#line 361 "serializer.c"
						const gchar* _tmp3_;
						const gchar* _tmp4_;
#line 92 "../lib/serializer.vala"
						_tmp3_ = s0;
#line 92 "../lib/serializer.vala"
						_tmp4_ = self->priv->zero_string;
#line 92 "../lib/serializer.vala"
						_tmp2_ = g_strcmp0 (_tmp3_, _tmp4_) != 0;
#line 370 "serializer.c"
					} else {
#line 92 "../lib/serializer.vala"
						_tmp2_ = FALSE;
#line 374 "serializer.c"
					}
#line 92 "../lib/serializer.vala"
					if (_tmp2_) {
#line 93 "../lib/serializer.vala"
						result = s0;
#line 93 "../lib/serializer.vala"
						return result;
#line 382 "serializer.c"
					} else {
						gchar* _tmp5_;
#line 95 "../lib/serializer.vala"
						_tmp5_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 95 "../lib/serializer.vala"
						result = _tmp5_;
#line 95 "../lib/serializer.vala"
						_g_free0 (s0);
#line 95 "../lib/serializer.vala"
						return result;
#line 393 "serializer.c"
					}
				}
#line 88 "../lib/serializer.vala"
				case 8:
#line 398 "serializer.c"
				{
					gboolean _tmp6_ = FALSE;
#line 98 "../lib/serializer.vala"
					if (n_digits <= 22) {
#line 403 "serializer.c"
						const gchar* _tmp7_;
						const gchar* _tmp8_;
#line 98 "../lib/serializer.vala"
						_tmp7_ = s0;
#line 98 "../lib/serializer.vala"
						_tmp8_ = self->priv->zero_string;
#line 98 "../lib/serializer.vala"
						_tmp6_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 412 "serializer.c"
					} else {
#line 98 "../lib/serializer.vala"
						_tmp6_ = FALSE;
#line 416 "serializer.c"
					}
#line 98 "../lib/serializer.vala"
					if (_tmp6_) {
#line 99 "../lib/serializer.vala"
						result = s0;
#line 99 "../lib/serializer.vala"
						return result;
#line 424 "serializer.c"
					} else {
						gchar* _tmp9_;
#line 101 "../lib/serializer.vala"
						_tmp9_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 101 "../lib/serializer.vala"
						result = _tmp9_;
#line 101 "../lib/serializer.vala"
						_g_free0 (s0);
#line 101 "../lib/serializer.vala"
						return result;
#line 435 "serializer.c"
					}
				}
#line 88 "../lib/serializer.vala"
				case 16:
#line 440 "serializer.c"
				{
					gboolean _tmp10_ = FALSE;
#line 104 "../lib/serializer.vala"
					if (n_digits <= 16) {
#line 445 "serializer.c"
						const gchar* _tmp11_;
						const gchar* _tmp12_;
#line 104 "../lib/serializer.vala"
						_tmp11_ = s0;
#line 104 "../lib/serializer.vala"
						_tmp12_ = self->priv->zero_string;
#line 104 "../lib/serializer.vala"
						_tmp10_ = g_strcmp0 (_tmp11_, _tmp12_) != 0;
#line 454 "serializer.c"
					} else {
#line 104 "../lib/serializer.vala"
						_tmp10_ = FALSE;
#line 458 "serializer.c"
					}
#line 104 "../lib/serializer.vala"
					if (_tmp10_) {
#line 105 "../lib/serializer.vala"
						result = s0;
#line 105 "../lib/serializer.vala"
						return result;
#line 466 "serializer.c"
					} else {
						gchar* _tmp13_;
#line 107 "../lib/serializer.vala"
						_tmp13_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 107 "../lib/serializer.vala"
						result = _tmp13_;
#line 107 "../lib/serializer.vala"
						_g_free0 (s0);
#line 107 "../lib/serializer.vala"
						return result;
#line 477 "serializer.c"
					}
				}
				default:
#line 88 "../lib/serializer.vala"
				case 10:
#line 483 "serializer.c"
				{
					gboolean _tmp14_ = FALSE;
#line 111 "../lib/serializer.vala"
					if (n_digits <= self->priv->leading_digits) {
#line 488 "serializer.c"
						const gchar* _tmp15_;
						const gchar* _tmp16_;
#line 111 "../lib/serializer.vala"
						_tmp15_ = s0;
#line 111 "../lib/serializer.vala"
						_tmp16_ = self->priv->zero_string;
#line 111 "../lib/serializer.vala"
						_tmp14_ = g_strcmp0 (_tmp15_, _tmp16_) != 0;
#line 497 "serializer.c"
					} else {
#line 111 "../lib/serializer.vala"
						_tmp14_ = FALSE;
#line 501 "serializer.c"
					}
#line 111 "../lib/serializer.vala"
					if (_tmp14_) {
#line 112 "../lib/serializer.vala"
						result = s0;
#line 112 "../lib/serializer.vala"
						return result;
#line 509 "serializer.c"
					} else {
						gchar* _tmp17_;
#line 115 "../lib/serializer.vala"
						serializer_set_error (self, NULL);
#line 116 "../lib/serializer.vala"
						_tmp17_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 116 "../lib/serializer.vala"
						result = _tmp17_;
#line 116 "../lib/serializer.vala"
						_g_free0 (s0);
#line 116 "../lib/serializer.vala"
						return result;
#line 522 "serializer.c"
					}
				}
			}
#line 81 "../lib/serializer.vala"
			_g_free0 (s0);
#line 528 "serializer.c"
		}
#line 81 "../lib/serializer.vala"
		case DISPLAY_FORMAT_FIXED:
#line 532 "serializer.c"
		{
			gint n_digits = 0;
			gchar* _tmp18_;
#line 120 "../lib/serializer.vala"
			n_digits = 0;
#line 121 "../lib/serializer.vala"
			_tmp18_ = serializer_cast_to_string (self, x, &n_digits);
#line 121 "../lib/serializer.vala"
			result = _tmp18_;
#line 121 "../lib/serializer.vala"
			return result;
#line 544 "serializer.c"
		}
#line 81 "../lib/serializer.vala"
		case DISPLAY_FORMAT_SCIENTIFIC:
#line 548 "serializer.c"
		{
#line 123 "../lib/serializer.vala"
			if (self->priv->representation_base == ((guint) 10)) {
#line 552 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp19_;
#line 125 "../lib/serializer.vala"
				serializer_set_error (self, NULL);
#line 126 "../lib/serializer.vala"
				n_digits = 0;
#line 127 "../lib/serializer.vala"
				_tmp19_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 127 "../lib/serializer.vala"
				result = _tmp19_;
#line 127 "../lib/serializer.vala"
				return result;
#line 565 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp20_;
#line 131 "../lib/serializer.vala"
				n_digits = 0;
#line 132 "../lib/serializer.vala"
				_tmp20_ = serializer_cast_to_string (self, x, &n_digits);
#line 132 "../lib/serializer.vala"
				result = _tmp20_;
#line 132 "../lib/serializer.vala"
				return result;
#line 577 "serializer.c"
			}
		}
#line 81 "../lib/serializer.vala"
		case DISPLAY_FORMAT_ENGINEERING:
#line 582 "serializer.c"
		{
#line 135 "../lib/serializer.vala"
			if (self->priv->representation_base == ((guint) 10)) {
#line 586 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp21_;
#line 137 "../lib/serializer.vala"
				serializer_set_error (self, NULL);
#line 138 "../lib/serializer.vala"
				n_digits = 0;
#line 139 "../lib/serializer.vala"
				_tmp21_ = serializer_cast_to_exponential_string (self, x, TRUE, &n_digits);
#line 139 "../lib/serializer.vala"
				result = _tmp21_;
#line 139 "../lib/serializer.vala"
				return result;
#line 599 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp22_;
#line 143 "../lib/serializer.vala"
				n_digits = 0;
#line 144 "../lib/serializer.vala"
				_tmp22_ = serializer_cast_to_string (self, x, &n_digits);
#line 144 "../lib/serializer.vala"
				result = _tmp22_;
#line 144 "../lib/serializer.vala"
				return result;
#line 611 "serializer.c"
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 159 "../lib/serializer.vala"
	return self ? g_object_ref (self) : NULL;
#line 622 "serializer.c"
}

gchar*
serializer_to_dms_string (Serializer* self,
                          Number* number)
{
	Number* eps = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	mpfr_prec_t _tmp2_;
	mpfr_prec_t _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* rounded_number = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	gboolean _tmp17_;
	Number* minute = NULL;
	Number* _tmp19_;
	Number* _tmp20_;
	Number* _tmp21_;
	Number* _tmp22_;
	Number* rounded_minute = NULL;
	Number* _tmp23_;
	Number* _tmp24_;
	Number* _tmp25_;
	Number* _tmp26_;
	Number* _tmp27_;
	Number* _tmp28_;
	Number* _tmp29_;
	Number* _tmp30_;
	Number* _tmp31_;
	gboolean _tmp32_;
	gchar* d = NULL;
	Number* _tmp35_;
	Number* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* m = NULL;
	Number* _tmp39_;
	Number* _tmp40_;
	Number* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* s = NULL;
	Number* _tmp44_;
	Number* _tmp45_;
	Number* _tmp46_;
	Number* _tmp47_;
	Number* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* result;
#line 149 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../lib/serializer.vala"
	g_return_val_if_fail (number != NULL, NULL);
#line 151 "../lib/serializer.vala"
	_tmp0_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 151 "../lib/serializer.vala"
	_tmp1_ = _tmp0_;
#line 151 "../lib/serializer.vala"
	_tmp2_ = number_get_precision ();
#line 151 "../lib/serializer.vala"
	_tmp3_ = _tmp2_;
#line 151 "../lib/serializer.vala"
	_tmp4_ = number_xpowy_integer (_tmp1_, (gint64) (8 - _tmp3_));
#line 151 "../lib/serializer.vala"
	_tmp5_ = _tmp4_;
#line 151 "../lib/serializer.vala"
	_tmp6_ = number_multiply (number, _tmp5_);
#line 151 "../lib/serializer.vala"
	_tmp7_ = _tmp6_;
#line 151 "../lib/serializer.vala"
	_tmp8_ = number_abs (_tmp7_);
#line 151 "../lib/serializer.vala"
	_tmp9_ = _tmp8_;
#line 151 "../lib/serializer.vala"
	_g_object_unref0 (_tmp7_);
#line 151 "../lib/serializer.vala"
	_g_object_unref0 (_tmp5_);
#line 151 "../lib/serializer.vala"
	_g_object_unref0 (_tmp1_);
#line 151 "../lib/serializer.vala"
	eps = _tmp9_;
#line 152 "../lib/serializer.vala"
	_tmp10_ = number_round (number);
#line 152 "../lib/serializer.vala"
	rounded_number = _tmp10_;
#line 153 "../lib/serializer.vala"
	_tmp11_ = rounded_number;
#line 153 "../lib/serializer.vala"
	_tmp12_ = number_subtract (number, _tmp11_);
#line 153 "../lib/serializer.vala"
	_tmp13_ = _tmp12_;
#line 153 "../lib/serializer.vala"
	_tmp14_ = number_abs (_tmp13_);
#line 153 "../lib/serializer.vala"
	_tmp15_ = _tmp14_;
#line 153 "../lib/serializer.vala"
	_tmp16_ = eps;
#line 153 "../lib/serializer.vala"
	_tmp17_ = number_compare (_tmp15_, _tmp16_) < 0;
#line 153 "../lib/serializer.vala"
	_g_object_unref0 (_tmp15_);
#line 153 "../lib/serializer.vala"
	_g_object_unref0 (_tmp13_);
#line 153 "../lib/serializer.vala"
	if (_tmp17_) {
#line 746 "serializer.c"
		Number* _tmp18_;
#line 154 "../lib/serializer.vala"
		_tmp18_ = rounded_number;
#line 154 "../lib/serializer.vala"
		number = _tmp18_;
#line 752 "serializer.c"
	}
#line 156 "../lib/serializer.vala"
	_tmp19_ = number_fractional_component (number);
#line 156 "../lib/serializer.vala"
	_tmp20_ = _tmp19_;
#line 156 "../lib/serializer.vala"
	_tmp21_ = number_multiply_integer (_tmp20_, (gint64) 60);
#line 156 "../lib/serializer.vala"
	_tmp22_ = _tmp21_;
#line 156 "../lib/serializer.vala"
	_g_object_unref0 (_tmp20_);
#line 156 "../lib/serializer.vala"
	minute = _tmp22_;
#line 157 "../lib/serializer.vala"
	_tmp23_ = minute;
#line 157 "../lib/serializer.vala"
	_tmp24_ = number_round (_tmp23_);
#line 157 "../lib/serializer.vala"
	rounded_minute = _tmp24_;
#line 158 "../lib/serializer.vala"
	_tmp25_ = minute;
#line 158 "../lib/serializer.vala"
	_tmp26_ = rounded_minute;
#line 158 "../lib/serializer.vala"
	_tmp27_ = number_subtract (_tmp25_, _tmp26_);
#line 158 "../lib/serializer.vala"
	_tmp28_ = _tmp27_;
#line 158 "../lib/serializer.vala"
	_tmp29_ = number_abs (_tmp28_);
#line 158 "../lib/serializer.vala"
	_tmp30_ = _tmp29_;
#line 158 "../lib/serializer.vala"
	_tmp31_ = eps;
#line 158 "../lib/serializer.vala"
	_tmp32_ = number_compare (_tmp30_, _tmp31_) < 0;
#line 158 "../lib/serializer.vala"
	_g_object_unref0 (_tmp30_);
#line 158 "../lib/serializer.vala"
	_g_object_unref0 (_tmp28_);
#line 158 "../lib/serializer.vala"
	if (_tmp32_) {
#line 794 "serializer.c"
		Number* _tmp33_;
		Number* _tmp34_;
#line 159 "../lib/serializer.vala"
		_tmp33_ = rounded_minute;
#line 159 "../lib/serializer.vala"
		_tmp34_ = _g_object_ref0 (_tmp33_);
#line 159 "../lib/serializer.vala"
		_g_object_unref0 (minute);
#line 159 "../lib/serializer.vala"
		minute = _tmp34_;
#line 805 "serializer.c"
	}
#line 161 "../lib/serializer.vala"
	_tmp35_ = number_integer_component (number);
#line 161 "../lib/serializer.vala"
	_tmp36_ = _tmp35_;
#line 161 "../lib/serializer.vala"
	_tmp37_ = serializer_to_string (self, _tmp36_);
#line 161 "../lib/serializer.vala"
	_tmp38_ = _tmp37_;
#line 161 "../lib/serializer.vala"
	_g_object_unref0 (_tmp36_);
#line 161 "../lib/serializer.vala"
	d = _tmp38_;
#line 162 "../lib/serializer.vala"
	_tmp39_ = minute;
#line 162 "../lib/serializer.vala"
	_tmp40_ = number_integer_component (_tmp39_);
#line 162 "../lib/serializer.vala"
	_tmp41_ = _tmp40_;
#line 162 "../lib/serializer.vala"
	_tmp42_ = serializer_to_string (self, _tmp41_);
#line 162 "../lib/serializer.vala"
	_tmp43_ = _tmp42_;
#line 162 "../lib/serializer.vala"
	_g_object_unref0 (_tmp41_);
#line 162 "../lib/serializer.vala"
	m = _tmp43_;
#line 163 "../lib/serializer.vala"
	_tmp44_ = minute;
#line 163 "../lib/serializer.vala"
	_tmp45_ = number_fractional_component (_tmp44_);
#line 163 "../lib/serializer.vala"
	_tmp46_ = _tmp45_;
#line 163 "../lib/serializer.vala"
	_tmp47_ = number_multiply_integer (_tmp46_, (gint64) 60);
#line 163 "../lib/serializer.vala"
	_tmp48_ = _tmp47_;
#line 163 "../lib/serializer.vala"
	_tmp49_ = serializer_to_string (self, _tmp48_);
#line 163 "../lib/serializer.vala"
	_tmp50_ = _tmp49_;
#line 163 "../lib/serializer.vala"
	_g_object_unref0 (_tmp48_);
#line 163 "../lib/serializer.vala"
	_g_object_unref0 (_tmp46_);
#line 163 "../lib/serializer.vala"
	s = _tmp50_;
#line 164 "../lib/serializer.vala"
	_tmp51_ = s;
#line 164 "../lib/serializer.vala"
	if (g_str_has_prefix (_tmp51_, "60")) {
#line 857 "serializer.c"
		const gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
#line 166 "../lib/serializer.vala"
		_tmp52_ = self->priv->zero_string;
#line 166 "../lib/serializer.vala"
		_tmp53_ = g_strdup (_tmp52_);
#line 166 "../lib/serializer.vala"
		_g_free0 (s);
#line 166 "../lib/serializer.vala"
		s = _tmp53_;
#line 167 "../lib/serializer.vala"
		_tmp54_ = m;
#line 167 "../lib/serializer.vala"
		if (g_str_has_prefix (_tmp54_, "59")) {
#line 873 "serializer.c"
			const gchar* _tmp55_;
			gchar* _tmp56_;
			Number* _tmp57_;
			Number* _tmp58_;
			Number* _tmp59_;
			Number* _tmp60_;
			Number* _tmp61_;
			Number* _tmp62_;
			gchar* _tmp63_;
#line 169 "../lib/serializer.vala"
			_tmp55_ = self->priv->zero_string;
#line 169 "../lib/serializer.vala"
			_tmp56_ = g_strdup (_tmp55_);
#line 169 "../lib/serializer.vala"
			_g_free0 (m);
#line 169 "../lib/serializer.vala"
			m = _tmp56_;
#line 170 "../lib/serializer.vala"
			_tmp57_ = number_integer_component (number);
#line 170 "../lib/serializer.vala"
			_tmp58_ = _tmp57_;
#line 170 "../lib/serializer.vala"
			_tmp59_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 170 "../lib/serializer.vala"
			_tmp60_ = _tmp59_;
#line 170 "../lib/serializer.vala"
			_tmp61_ = number_add (_tmp58_, _tmp60_);
#line 170 "../lib/serializer.vala"
			_tmp62_ = _tmp61_;
#line 170 "../lib/serializer.vala"
			_tmp63_ = serializer_to_string (self, _tmp62_);
#line 170 "../lib/serializer.vala"
			_g_free0 (d);
#line 170 "../lib/serializer.vala"
			d = _tmp63_;
#line 170 "../lib/serializer.vala"
			_g_object_unref0 (_tmp62_);
#line 170 "../lib/serializer.vala"
			_g_object_unref0 (_tmp60_);
#line 170 "../lib/serializer.vala"
			_g_object_unref0 (_tmp58_);
#line 915 "serializer.c"
		} else {
			Number* _tmp64_;
			Number* _tmp65_;
			Number* _tmp66_;
			Number* _tmp67_;
			Number* _tmp68_;
			Number* _tmp69_;
			Number* _tmp70_;
			gchar* _tmp71_;
#line 173 "../lib/serializer.vala"
			_tmp64_ = minute;
#line 173 "../lib/serializer.vala"
			_tmp65_ = number_integer_component (_tmp64_);
#line 173 "../lib/serializer.vala"
			_tmp66_ = _tmp65_;
#line 173 "../lib/serializer.vala"
			_tmp67_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 173 "../lib/serializer.vala"
			_tmp68_ = _tmp67_;
#line 173 "../lib/serializer.vala"
			_tmp69_ = number_add (_tmp66_, _tmp68_);
#line 173 "../lib/serializer.vala"
			_tmp70_ = _tmp69_;
#line 173 "../lib/serializer.vala"
			_tmp71_ = serializer_to_string (self, _tmp70_);
#line 173 "../lib/serializer.vala"
			_g_free0 (m);
#line 173 "../lib/serializer.vala"
			m = _tmp71_;
#line 173 "../lib/serializer.vala"
			_g_object_unref0 (_tmp70_);
#line 173 "../lib/serializer.vala"
			_g_object_unref0 (_tmp68_);
#line 173 "../lib/serializer.vala"
			_g_object_unref0 (_tmp66_);
#line 951 "serializer.c"
		}
	}
#line 175 "../lib/serializer.vala"
	_tmp72_ = d;
#line 175 "../lib/serializer.vala"
	_tmp73_ = m;
#line 175 "../lib/serializer.vala"
	_tmp74_ = s;
#line 175 "../lib/serializer.vala"
	_tmp75_ = g_strdup_printf ("%s°%s′%s″", _tmp72_, _tmp73_, _tmp74_);
#line 175 "../lib/serializer.vala"
	result = _tmp75_;
#line 175 "../lib/serializer.vala"
	_g_free0 (s);
#line 175 "../lib/serializer.vala"
	_g_free0 (m);
#line 175 "../lib/serializer.vala"
	_g_free0 (d);
#line 175 "../lib/serializer.vala"
	_g_object_unref0 (rounded_minute);
#line 175 "../lib/serializer.vala"
	_g_object_unref0 (minute);
#line 175 "../lib/serializer.vala"
	_g_object_unref0 (rounded_number);
#line 175 "../lib/serializer.vala"
	_g_object_unref0 (eps);
#line 175 "../lib/serializer.vala"
	return result;
#line 980 "serializer.c"
}

Number*
serializer_from_string (Serializer* self,
                        const gchar* str)
{
	Number* _tmp0_;
	Number* result;
#line 178 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../lib/serializer.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 181 "../lib/serializer.vala"
	_tmp0_ = mp_set_from_string (str, self->priv->number_base, TRUE);
#line 181 "../lib/serializer.vala"
	result = _tmp0_;
#line 181 "../lib/serializer.vala"
	return result;
#line 999 "serializer.c"
}

void
serializer_set_base (Serializer* self,
                     gint number_base)
{
#line 184 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/serializer.vala"
	self->priv->number_base = number_base;
#line 1010 "serializer.c"
}

gint
serializer_get_base (Serializer* self)
{
	gint result;
#line 189 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 191 "../lib/serializer.vala"
	result = self->priv->number_base;
#line 191 "../lib/serializer.vala"
	return result;
#line 1023 "serializer.c"
}

void
serializer_set_representation_base (Serializer* self,
                                    guint representation_base)
{
#line 194 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/serializer.vala"
	self->priv->representation_base = representation_base;
#line 1034 "serializer.c"
}

guint
serializer_get_representation_base (Serializer* self)
{
	guint result;
#line 199 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 201 "../lib/serializer.vala"
	result = self->priv->representation_base;
#line 201 "../lib/serializer.vala"
	return result;
#line 1047 "serializer.c"
}

void
serializer_set_radix (Serializer* self,
                      gunichar radix)
{
#line 204 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 206 "../lib/serializer.vala"
	self->priv->radix = radix;
#line 207 "../lib/serializer.vala"
	serializer_update_zero_string (self);
#line 1060 "serializer.c"
}

gunichar
serializer_get_radix (Serializer* self)
{
	gunichar result;
#line 210 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 212 "../lib/serializer.vala"
	result = self->priv->radix;
#line 212 "../lib/serializer.vala"
	return result;
#line 1073 "serializer.c"
}

void
serializer_set_thousands_separator (Serializer* self,
                                    gunichar separator)
{
#line 215 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 217 "../lib/serializer.vala"
	self->priv->tsep = separator;
#line 1084 "serializer.c"
}

gunichar
serializer_get_thousands_separator (Serializer* self)
{
	gunichar result;
#line 220 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 222 "../lib/serializer.vala"
	result = self->priv->tsep;
#line 222 "../lib/serializer.vala"
	return result;
#line 1097 "serializer.c"
}

gint
serializer_get_thousands_separator_count (Serializer* self)
{
	gint result;
#line 225 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 227 "../lib/serializer.vala"
	result = self->priv->tsep_count;
#line 227 "../lib/serializer.vala"
	return result;
#line 1110 "serializer.c"
}

void
serializer_set_thousands_separator_count (Serializer* self,
                                          gint count)
{
#line 230 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 232 "../lib/serializer.vala"
	self->priv->tsep_count = count;
#line 1121 "serializer.c"
}

void
serializer_set_show_thousands_separators (Serializer* self,
                                          gboolean visible)
{
#line 235 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 237 "../lib/serializer.vala"
	self->priv->show_tsep = visible;
#line 1132 "serializer.c"
}

gboolean
serializer_get_show_thousands_separators (Serializer* self)
{
	gboolean result;
#line 240 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 242 "../lib/serializer.vala"
	result = self->priv->show_tsep;
#line 242 "../lib/serializer.vala"
	return result;
#line 1145 "serializer.c"
}

void
serializer_set_show_trailing_zeroes (Serializer* self,
                                     gboolean visible)
{
#line 245 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 247 "../lib/serializer.vala"
	self->priv->show_zeroes = visible;
#line 248 "../lib/serializer.vala"
	serializer_update_zero_string (self);
#line 1158 "serializer.c"
}

gboolean
serializer_get_show_trailing_zeroes (Serializer* self)
{
	gboolean result;
#line 251 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 253 "../lib/serializer.vala"
	result = self->priv->show_zeroes;
#line 253 "../lib/serializer.vala"
	return result;
#line 1171 "serializer.c"
}

gint
serializer_get_leading_digits (Serializer* self)
{
	gint result;
#line 256 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 258 "../lib/serializer.vala"
	result = self->priv->leading_digits;
#line 258 "../lib/serializer.vala"
	return result;
#line 1184 "serializer.c"
}

void
serializer_set_leading_digits (Serializer* self,
                               gint leading_digits)
{
#line 261 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 263 "../lib/serializer.vala"
	self->priv->leading_digits = leading_digits;
#line 1195 "serializer.c"
}

gint
serializer_get_trailing_digits (Serializer* self)
{
	gint result;
#line 266 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 268 "../lib/serializer.vala"
	result = self->priv->trailing_digits;
#line 268 "../lib/serializer.vala"
	return result;
#line 1208 "serializer.c"
}

void
serializer_set_trailing_digits (Serializer* self,
                                gint trailing_digits)
{
#line 271 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 273 "../lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 274 "../lib/serializer.vala"
	serializer_update_zero_string (self);
#line 1221 "serializer.c"
}

DisplayFormat
serializer_get_number_format (Serializer* self)
{
	DisplayFormat result;
#line 277 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 279 "../lib/serializer.vala"
	result = self->priv->format;
#line 279 "../lib/serializer.vala"
	return result;
#line 1234 "serializer.c"
}

void
serializer_set_number_format (Serializer* self,
                              DisplayFormat format)
{
#line 282 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 284 "../lib/serializer.vala"
	self->priv->format = format;
#line 1245 "serializer.c"
}

static void
serializer_update_zero_string (Serializer* self)
{
	gint n_digits = 0;
	Number* _tmp0_;
	Number* _tmp1_;
	gchar* _tmp2_;
#line 287 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 289 "../lib/serializer.vala"
	n_digits = 0;
#line 290 "../lib/serializer.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 290 "../lib/serializer.vala"
	_tmp1_ = _tmp0_;
#line 290 "../lib/serializer.vala"
	_tmp2_ = serializer_cast_to_string (self, _tmp1_, &n_digits);
#line 290 "../lib/serializer.vala"
	_g_free0 (self->priv->zero_string);
#line 290 "../lib/serializer.vala"
	self->priv->zero_string = _tmp2_;
#line 290 "../lib/serializer.vala"
	_g_object_unref0 (_tmp1_);
#line 1271 "serializer.c"
}

static gchar*
serializer_cast_to_string (Serializer* self,
                           Number* x,
                           gint* n_digits)
{
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	GString* _tmp3_;
	GString* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* result;
#line 293 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 295 "../lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 295 "../lib/serializer.vala"
	string = _tmp0_;
#line 297 "../lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 297 "../lib/serializer.vala"
	x_real = _tmp1_;
#line 298 "../lib/serializer.vala"
	_tmp2_ = x_real;
#line 298 "../lib/serializer.vala"
	_tmp3_ = string;
#line 298 "../lib/serializer.vala"
	serializer_cast_to_string_real (self, _tmp2_, (gint) self->priv->representation_base, FALSE, n_digits, _tmp3_);
#line 299 "../lib/serializer.vala"
	if (number_is_complex (x)) {
#line 1309 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp4_;
		gboolean force_sign = FALSE;
		GString* _tmp5_;
		const gchar* _tmp6_;
		GString* s = NULL;
		GString* _tmp8_;
		gint n_complex_digits = 0;
		Number* _tmp9_;
		GString* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 301 "../lib/serializer.vala"
		_tmp4_ = number_imaginary_component (x);
#line 301 "../lib/serializer.vala"
		x_im = _tmp4_;
#line 303 "../lib/serializer.vala"
		force_sign = TRUE;
#line 304 "../lib/serializer.vala"
		_tmp5_ = string;
#line 304 "../lib/serializer.vala"
		_tmp6_ = _tmp5_->str;
#line 304 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp6_, "0") == 0) {
#line 1336 "serializer.c"
			GString* _tmp7_;
#line 306 "../lib/serializer.vala"
			_tmp7_ = string;
#line 306 "../lib/serializer.vala"
			g_string_assign (_tmp7_, "");
#line 307 "../lib/serializer.vala"
			force_sign = FALSE;
#line 1344 "serializer.c"
		}
#line 310 "../lib/serializer.vala"
		_tmp8_ = g_string_sized_new ((gsize) 1024);
#line 310 "../lib/serializer.vala"
		s = _tmp8_;
#line 311 "../lib/serializer.vala"
		n_complex_digits = 0;
#line 312 "../lib/serializer.vala"
		_tmp9_ = x_im;
#line 312 "../lib/serializer.vala"
		_tmp10_ = s;
#line 312 "../lib/serializer.vala"
		serializer_cast_to_string_real (self, _tmp9_, (gint) self->priv->representation_base, force_sign, &n_complex_digits, _tmp10_);
#line 313 "../lib/serializer.vala"
		if (n_complex_digits > (*n_digits)) {
#line 314 "../lib/serializer.vala"
			*n_digits = n_complex_digits;
#line 1362 "serializer.c"
		}
#line 315 "../lib/serializer.vala"
		_tmp13_ = s;
#line 315 "../lib/serializer.vala"
		_tmp14_ = _tmp13_->str;
#line 315 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp14_, "0") == 0) {
#line 315 "../lib/serializer.vala"
			_tmp12_ = TRUE;
#line 1372 "serializer.c"
		} else {
			GString* _tmp15_;
			const gchar* _tmp16_;
#line 315 "../lib/serializer.vala"
			_tmp15_ = s;
#line 315 "../lib/serializer.vala"
			_tmp16_ = _tmp15_->str;
#line 315 "../lib/serializer.vala"
			_tmp12_ = g_strcmp0 (_tmp16_, "+0") == 0;
#line 1382 "serializer.c"
		}
#line 315 "../lib/serializer.vala"
		if (_tmp12_) {
#line 315 "../lib/serializer.vala"
			_tmp11_ = TRUE;
#line 1388 "serializer.c"
		} else {
			GString* _tmp17_;
			const gchar* _tmp18_;
#line 315 "../lib/serializer.vala"
			_tmp17_ = s;
#line 315 "../lib/serializer.vala"
			_tmp18_ = _tmp17_->str;
#line 315 "../lib/serializer.vala"
			_tmp11_ = g_strcmp0 (_tmp18_, "−0") == 0;
#line 1398 "serializer.c"
		}
#line 315 "../lib/serializer.vala"
		if (_tmp11_) {
#line 1402 "serializer.c"
			GString* _tmp19_;
			const gchar* _tmp20_;
#line 317 "../lib/serializer.vala"
			_tmp19_ = string;
#line 317 "../lib/serializer.vala"
			_tmp20_ = _tmp19_->str;
#line 317 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp20_, "") == 0) {
#line 1411 "serializer.c"
				GString* _tmp21_;
#line 319 "../lib/serializer.vala"
				_tmp21_ = string;
#line 319 "../lib/serializer.vala"
				g_string_append (_tmp21_, "0");
#line 1417 "serializer.c"
			}
		} else {
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 322 "../lib/serializer.vala"
			_tmp22_ = s;
#line 322 "../lib/serializer.vala"
			_tmp23_ = _tmp22_->str;
#line 322 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp23_, "1") == 0) {
#line 1428 "serializer.c"
				GString* _tmp24_;
#line 324 "../lib/serializer.vala"
				_tmp24_ = string;
#line 324 "../lib/serializer.vala"
				g_string_append (_tmp24_, "i");
#line 1434 "serializer.c"
			} else {
				GString* _tmp25_;
				const gchar* _tmp26_;
#line 326 "../lib/serializer.vala"
				_tmp25_ = s;
#line 326 "../lib/serializer.vala"
				_tmp26_ = _tmp25_->str;
#line 326 "../lib/serializer.vala"
				if (g_strcmp0 (_tmp26_, "+1") == 0) {
#line 1444 "serializer.c"
					GString* _tmp27_;
#line 328 "../lib/serializer.vala"
					_tmp27_ = string;
#line 328 "../lib/serializer.vala"
					g_string_append (_tmp27_, "+i");
#line 1450 "serializer.c"
				} else {
					GString* _tmp28_;
					const gchar* _tmp29_;
#line 330 "../lib/serializer.vala"
					_tmp28_ = s;
#line 330 "../lib/serializer.vala"
					_tmp29_ = _tmp28_->str;
#line 330 "../lib/serializer.vala"
					if (g_strcmp0 (_tmp29_, "−1") == 0) {
#line 1460 "serializer.c"
						GString* _tmp30_;
#line 332 "../lib/serializer.vala"
						_tmp30_ = string;
#line 332 "../lib/serializer.vala"
						g_string_append (_tmp30_, "−i");
#line 1466 "serializer.c"
					} else {
						GString* _tmp31_;
						const gchar* _tmp32_;
						GString* _tmp39_;
#line 336 "../lib/serializer.vala"
						_tmp31_ = s;
#line 336 "../lib/serializer.vala"
						_tmp32_ = _tmp31_->str;
#line 336 "../lib/serializer.vala"
						if (g_strcmp0 (_tmp32_, "+0") == 0) {
#line 1477 "serializer.c"
							GString* _tmp33_;
#line 337 "../lib/serializer.vala"
							_tmp33_ = string;
#line 337 "../lib/serializer.vala"
							g_string_append (_tmp33_, "+");
#line 1483 "serializer.c"
						} else {
							GString* _tmp34_;
							const gchar* _tmp35_;
#line 338 "../lib/serializer.vala"
							_tmp34_ = s;
#line 338 "../lib/serializer.vala"
							_tmp35_ = _tmp34_->str;
#line 338 "../lib/serializer.vala"
							if (g_strcmp0 (_tmp35_, "0") != 0) {
#line 1493 "serializer.c"
								GString* _tmp36_;
								GString* _tmp37_;
								const gchar* _tmp38_;
#line 339 "../lib/serializer.vala"
								_tmp36_ = string;
#line 339 "../lib/serializer.vala"
								_tmp37_ = s;
#line 339 "../lib/serializer.vala"
								_tmp38_ = _tmp37_->str;
#line 339 "../lib/serializer.vala"
								g_string_append (_tmp36_, _tmp38_);
#line 1505 "serializer.c"
							}
						}
#line 341 "../lib/serializer.vala"
						_tmp39_ = string;
#line 341 "../lib/serializer.vala"
						g_string_append (_tmp39_, "i");
#line 1512 "serializer.c"
					}
				}
			}
		}
#line 299 "../lib/serializer.vala"
		_g_string_free0 (s);
#line 299 "../lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 1521 "serializer.c"
	}
#line 345 "../lib/serializer.vala"
	_tmp40_ = string;
#line 345 "../lib/serializer.vala"
	_tmp41_ = _tmp40_->str;
#line 345 "../lib/serializer.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 345 "../lib/serializer.vala"
	result = _tmp42_;
#line 345 "../lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 345 "../lib/serializer.vala"
	_g_string_free0 (string);
#line 345 "../lib/serializer.vala"
	return result;
#line 1537 "serializer.c"
}

static void
serializer_cast_to_string_real (Serializer* self,
                                Number* x,
                                gint number_base,
                                gboolean force_sign,
                                gint* n_digits,
                                GString* string)
{
#line 350 "../lib/serializer.vala"
	static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 1550 "serializer.c"
	Number* number = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* temp = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* rounded_number = NULL;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	gint i = 0;
	gssize last_non_zero = 0L;
	Number* _tmp37_;
	Number* _tmp38_;
	gboolean _tmp51_ = FALSE;
	gboolean _tmp52_ = FALSE;
	const gchar* _tmp53_;
#line 348 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 348 "../lib/serializer.vala"
	g_return_if_fail (x != NULL);
#line 348 "../lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 352 "../lib/serializer.vala"
	_tmp0_ = _g_object_ref0 (x);
#line 352 "../lib/serializer.vala"
	number = _tmp0_;
#line 353 "../lib/serializer.vala"
	_tmp1_ = number;
#line 353 "../lib/serializer.vala"
	if (number_is_negative (_tmp1_)) {
#line 1589 "serializer.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 354 "../lib/serializer.vala"
		_tmp2_ = number;
#line 354 "../lib/serializer.vala"
		_tmp3_ = number_abs (_tmp2_);
#line 354 "../lib/serializer.vala"
		_g_object_unref0 (number);
#line 354 "../lib/serializer.vala"
		number = _tmp3_;
#line 1600 "serializer.c"
	}
#line 357 "../lib/serializer.vala"
	_tmp4_ = number_new_integer ((gint64) number_base, (gint64) 0);
#line 357 "../lib/serializer.vala"
	temp = _tmp4_;
#line 358 "../lib/serializer.vala"
	_tmp5_ = temp;
#line 358 "../lib/serializer.vala"
	_tmp6_ = number_xpowy_integer (_tmp5_, (gint64) (-(self->priv->trailing_digits + 1)));
#line 358 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 358 "../lib/serializer.vala"
	temp = _tmp6_;
#line 359 "../lib/serializer.vala"
	_tmp7_ = temp;
#line 359 "../lib/serializer.vala"
	_tmp8_ = number_multiply_integer (_tmp7_, (gint64) number_base);
#line 359 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 359 "../lib/serializer.vala"
	temp = _tmp8_;
#line 360 "../lib/serializer.vala"
	_tmp9_ = temp;
#line 360 "../lib/serializer.vala"
	_tmp10_ = number_divide_integer (_tmp9_, (gint64) 2);
#line 360 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 360 "../lib/serializer.vala"
	temp = _tmp10_;
#line 361 "../lib/serializer.vala"
	_tmp11_ = number;
#line 361 "../lib/serializer.vala"
	_tmp12_ = temp;
#line 361 "../lib/serializer.vala"
	_tmp13_ = number_add (_tmp11_, _tmp12_);
#line 361 "../lib/serializer.vala"
	rounded_number = _tmp13_;
#line 364 "../lib/serializer.vala"
	_tmp14_ = rounded_number;
#line 364 "../lib/serializer.vala"
	_tmp15_ = number_floor (_tmp14_);
#line 364 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 364 "../lib/serializer.vala"
	temp = _tmp15_;
#line 365 "../lib/serializer.vala"
	i = 0;
#line 1648 "serializer.c"
	{
		gboolean _tmp16_ = FALSE;
#line 366 "../lib/serializer.vala"
		_tmp16_ = TRUE;
#line 366 "../lib/serializer.vala"
		while (TRUE) {
#line 1655 "serializer.c"
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			Number* t = NULL;
			Number* _tmp21_;
			Number* _tmp22_;
			Number* _tmp23_;
			Number* _tmp24_;
			Number* t2 = NULL;
			Number* _tmp25_;
			Number* _tmp26_;
			Number* t3 = NULL;
			Number* _tmp27_;
			Number* _tmp28_;
			Number* _tmp29_;
			gint64 d = 0LL;
			Number* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gint _tmp34_;
			Number* _tmp35_;
			Number* _tmp36_;
#line 366 "../lib/serializer.vala"
			if (!_tmp16_) {
#line 1679 "serializer.c"
				Number* _tmp17_;
#line 397 "../lib/serializer.vala"
				_tmp17_ = temp;
#line 397 "../lib/serializer.vala"
				if (!(!number_is_zero (_tmp17_))) {
#line 397 "../lib/serializer.vala"
					break;
#line 1687 "serializer.c"
				}
			}
#line 366 "../lib/serializer.vala"
			_tmp16_ = FALSE;
#line 368 "../lib/serializer.vala"
			if (number_base == 10) {
#line 368 "../lib/serializer.vala"
				_tmp19_ = self->priv->show_tsep;
#line 1696 "serializer.c"
			} else {
#line 368 "../lib/serializer.vala"
				_tmp19_ = FALSE;
#line 1700 "serializer.c"
			}
#line 368 "../lib/serializer.vala"
			if (_tmp19_) {
#line 368 "../lib/serializer.vala"
				_tmp18_ = i == self->priv->tsep_count;
#line 1706 "serializer.c"
			} else {
#line 368 "../lib/serializer.vala"
				_tmp18_ = FALSE;
#line 1710 "serializer.c"
			}
#line 368 "../lib/serializer.vala"
			if (_tmp18_) {
#line 370 "../lib/serializer.vala"
				g_string_prepend_unichar (string, self->priv->tsep);
#line 371 "../lib/serializer.vala"
				i = 0;
#line 1718 "serializer.c"
			}
#line 373 "../lib/serializer.vala"
			_tmp20_ = i;
#line 373 "../lib/serializer.vala"
			i = _tmp20_ + 1;
#line 375 "../lib/serializer.vala"
			_tmp21_ = temp;
#line 375 "../lib/serializer.vala"
			_tmp22_ = number_divide_integer (_tmp21_, (gint64) number_base);
#line 375 "../lib/serializer.vala"
			t = _tmp22_;
#line 376 "../lib/serializer.vala"
			_tmp23_ = t;
#line 376 "../lib/serializer.vala"
			_tmp24_ = number_floor (_tmp23_);
#line 376 "../lib/serializer.vala"
			_g_object_unref0 (t);
#line 376 "../lib/serializer.vala"
			t = _tmp24_;
#line 377 "../lib/serializer.vala"
			_tmp25_ = t;
#line 377 "../lib/serializer.vala"
			_tmp26_ = number_multiply_integer (_tmp25_, (gint64) number_base);
#line 377 "../lib/serializer.vala"
			t2 = _tmp26_;
#line 379 "../lib/serializer.vala"
			_tmp27_ = temp;
#line 379 "../lib/serializer.vala"
			_tmp28_ = t2;
#line 379 "../lib/serializer.vala"
			_tmp29_ = number_subtract (_tmp27_, _tmp28_);
#line 379 "../lib/serializer.vala"
			t3 = _tmp29_;
#line 381 "../lib/serializer.vala"
			_tmp30_ = t3;
#line 381 "../lib/serializer.vala"
			d = number_to_integer (_tmp30_);
#line 383 "../lib/serializer.vala"
			if (d < ((gint64) 16)) {
#line 383 "../lib/serializer.vala"
				_tmp31_ = d >= ((gint64) 0);
#line 1760 "serializer.c"
			} else {
#line 383 "../lib/serializer.vala"
				_tmp31_ = FALSE;
#line 1764 "serializer.c"
			}
#line 383 "../lib/serializer.vala"
			if (_tmp31_) {
#line 1768 "serializer.c"
				gchar _tmp32_;
#line 385 "../lib/serializer.vala"
				_tmp32_ = digits[d];
#line 385 "../lib/serializer.vala"
				g_string_prepend_c (string, _tmp32_);
#line 1774 "serializer.c"
			} else {
				const gchar* _tmp33_;
#line 389 "../lib/serializer.vala"
				g_string_prepend_c (string, '?');
#line 390 "../lib/serializer.vala"
				serializer_set_error (self, _ ("The result is too long to display in fixed format. Try other result fo" \
"rmats"));
#line 391 "../lib/serializer.vala"
				_tmp33_ = self->priv->zero_string;
#line 391 "../lib/serializer.vala"
				g_string_assign (string, _tmp33_);
#line 392 "../lib/serializer.vala"
				_g_object_unref0 (t3);
#line 392 "../lib/serializer.vala"
				_g_object_unref0 (t2);
#line 392 "../lib/serializer.vala"
				_g_object_unref0 (t);
#line 392 "../lib/serializer.vala"
				_g_object_unref0 (rounded_number);
#line 392 "../lib/serializer.vala"
				_g_object_unref0 (temp);
#line 392 "../lib/serializer.vala"
				_g_object_unref0 (number);
#line 392 "../lib/serializer.vala"
				return;
#line 1799 "serializer.c"
			}
#line 394 "../lib/serializer.vala"
			_tmp34_ = *n_digits;
#line 394 "../lib/serializer.vala"
			*n_digits = _tmp34_ + 1;
#line 396 "../lib/serializer.vala"
			_tmp35_ = t;
#line 396 "../lib/serializer.vala"
			_tmp36_ = _g_object_ref0 (_tmp35_);
#line 396 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 396 "../lib/serializer.vala"
			temp = _tmp36_;
#line 366 "../lib/serializer.vala"
			_g_object_unref0 (t3);
#line 366 "../lib/serializer.vala"
			_g_object_unref0 (t2);
#line 366 "../lib/serializer.vala"
			_g_object_unref0 (t);
#line 1819 "serializer.c"
		}
	}
#line 399 "../lib/serializer.vala"
	last_non_zero = string->len;
#line 401 "../lib/serializer.vala"
	g_string_append_unichar (string, self->priv->radix);
#line 404 "../lib/serializer.vala"
	_tmp37_ = rounded_number;
#line 404 "../lib/serializer.vala"
	_tmp38_ = number_fractional_component (_tmp37_);
#line 404 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 404 "../lib/serializer.vala"
	temp = _tmp38_;
#line 1834 "serializer.c"
	{
		gboolean _tmp39_ = FALSE;
#line 405 "../lib/serializer.vala"
		i = 0;
#line 405 "../lib/serializer.vala"
		_tmp39_ = TRUE;
#line 405 "../lib/serializer.vala"
		while (TRUE) {
#line 1843 "serializer.c"
			Number* _tmp41_;
			Number* _tmp42_;
			Number* _tmp43_;
			Number* digit = NULL;
			Number* _tmp44_;
			Number* _tmp45_;
			gint64 d = 0LL;
			Number* _tmp46_;
			gchar _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
			Number* _tmp50_;
#line 405 "../lib/serializer.vala"
			if (!_tmp39_) {
#line 1858 "serializer.c"
				gint _tmp40_;
#line 405 "../lib/serializer.vala"
				_tmp40_ = i;
#line 405 "../lib/serializer.vala"
				i = _tmp40_ + 1;
#line 1864 "serializer.c"
			}
#line 405 "../lib/serializer.vala"
			_tmp39_ = FALSE;
#line 405 "../lib/serializer.vala"
			if (!(i < self->priv->trailing_digits)) {
#line 405 "../lib/serializer.vala"
				break;
#line 1872 "serializer.c"
			}
#line 407 "../lib/serializer.vala"
			_tmp41_ = temp;
#line 407 "../lib/serializer.vala"
			if (number_is_zero (_tmp41_)) {
#line 408 "../lib/serializer.vala"
				break;
#line 1880 "serializer.c"
			}
#line 410 "../lib/serializer.vala"
			_tmp42_ = temp;
#line 410 "../lib/serializer.vala"
			_tmp43_ = number_multiply_integer (_tmp42_, (gint64) number_base);
#line 410 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 410 "../lib/serializer.vala"
			temp = _tmp43_;
#line 411 "../lib/serializer.vala"
			_tmp44_ = temp;
#line 411 "../lib/serializer.vala"
			_tmp45_ = number_floor (_tmp44_);
#line 411 "../lib/serializer.vala"
			digit = _tmp45_;
#line 412 "../lib/serializer.vala"
			_tmp46_ = digit;
#line 412 "../lib/serializer.vala"
			d = number_to_integer (_tmp46_);
#line 414 "../lib/serializer.vala"
			_tmp47_ = digits[d];
#line 414 "../lib/serializer.vala"
			g_string_append_c (string, _tmp47_);
#line 416 "../lib/serializer.vala"
			if (d != ((gint64) 0)) {
#line 417 "../lib/serializer.vala"
				last_non_zero = string->len;
#line 1908 "serializer.c"
			}
#line 418 "../lib/serializer.vala"
			_tmp48_ = temp;
#line 418 "../lib/serializer.vala"
			_tmp49_ = digit;
#line 418 "../lib/serializer.vala"
			_tmp50_ = number_subtract (_tmp48_, _tmp49_);
#line 418 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 418 "../lib/serializer.vala"
			temp = _tmp50_;
#line 405 "../lib/serializer.vala"
			_g_object_unref0 (digit);
#line 1922 "serializer.c"
		}
	}
#line 422 "../lib/serializer.vala"
	if (!self->priv->show_zeroes) {
#line 422 "../lib/serializer.vala"
		_tmp51_ = TRUE;
#line 1929 "serializer.c"
	} else {
#line 422 "../lib/serializer.vala"
		_tmp51_ = self->priv->trailing_digits == 0;
#line 1933 "serializer.c"
	}
#line 422 "../lib/serializer.vala"
	if (_tmp51_) {
#line 423 "../lib/serializer.vala"
		g_string_truncate (string, (gsize) last_non_zero);
#line 1939 "serializer.c"
	}
#line 426 "../lib/serializer.vala"
	_tmp53_ = string->str;
#line 426 "../lib/serializer.vala"
	if (g_strcmp0 (_tmp53_, "0") != 0) {
#line 426 "../lib/serializer.vala"
		_tmp52_ = TRUE;
#line 1947 "serializer.c"
	} else {
#line 426 "../lib/serializer.vala"
		_tmp52_ = force_sign;
#line 1951 "serializer.c"
	}
#line 426 "../lib/serializer.vala"
	if (_tmp52_) {
#line 428 "../lib/serializer.vala"
		if (number_is_negative (x)) {
#line 429 "../lib/serializer.vala"
			g_string_prepend (string, "−");
#line 1959 "serializer.c"
		} else {
#line 430 "../lib/serializer.vala"
			if (force_sign) {
#line 431 "../lib/serializer.vala"
				g_string_prepend (string, "+");
#line 1965 "serializer.c"
			}
		}
	}
#line 435 "../lib/serializer.vala"
	if (number_base != self->priv->number_base) {
#line 437 "../lib/serializer.vala"
		static const gchar* sub_digits[10] = {"₀", "₁", "₂", "₃", "₄", "₅", "₆", "₇", "₈", "₉"};
#line 1973 "serializer.c"
		gint multiplier = 0;
		gint b = 0;
#line 438 "../lib/serializer.vala"
		multiplier = 1;
#line 439 "../lib/serializer.vala"
		b = number_base;
#line 441 "../lib/serializer.vala"
		while (TRUE) {
#line 441 "../lib/serializer.vala"
			if (!((number_base / multiplier) != 0)) {
#line 441 "../lib/serializer.vala"
				break;
#line 1986 "serializer.c"
			}
#line 442 "../lib/serializer.vala"
			multiplier *= 10;
#line 1990 "serializer.c"
		}
#line 443 "../lib/serializer.vala"
		while (TRUE) {
#line 1994 "serializer.c"
			gint d = 0;
			const gchar* _tmp54_;
#line 443 "../lib/serializer.vala"
			if (!(multiplier != 1)) {
#line 443 "../lib/serializer.vala"
				break;
#line 2001 "serializer.c"
			}
#line 446 "../lib/serializer.vala"
			multiplier /= 10;
#line 447 "../lib/serializer.vala"
			d = b / multiplier;
#line 448 "../lib/serializer.vala"
			_tmp54_ = sub_digits[d];
#line 448 "../lib/serializer.vala"
			g_string_append (string, _tmp54_);
#line 449 "../lib/serializer.vala"
			b -= d * multiplier;
#line 2013 "serializer.c"
		}
	}
#line 348 "../lib/serializer.vala"
	_g_object_unref0 (rounded_number);
#line 348 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 348 "../lib/serializer.vala"
	_g_object_unref0 (number);
#line 2022 "serializer.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2044 "serializer.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2048 "serializer.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2054 "serializer.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2058 "serializer.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2062 "serializer.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 2070 "serializer.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2098 "serializer.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 2107 "serializer.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2121 "serializer.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 2130 "serializer.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 2144 "serializer.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2153 "serializer.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 2162 "serializer.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 2181 "serializer.c"
}

static gchar*
string_splice (const gchar* self,
               glong start,
               glong end,
               const gchar* str)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gsize str_size = 0UL;
	const gchar* _result_ = NULL;
	void* _tmp6_;
	gchar* dest = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* result;
#line 1548 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1549 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1549 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1549 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1550 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1551 "glib-2.0.vapi"
		start = string_length + start;
#line 2217 "serializer.c"
	}
#line 1553 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1554 "glib-2.0.vapi"
		end = string_length + end;
#line 2223 "serializer.c"
	}
#line 1556 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1556 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 2229 "serializer.c"
	} else {
#line 1556 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 2233 "serializer.c"
	}
#line 1556 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1557 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1557 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 2241 "serializer.c"
	} else {
#line 1557 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 2245 "serializer.c"
	}
#line 1557 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1558 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1561 "glib-2.0.vapi"
	if (str == NULL) {
#line 1562 "glib-2.0.vapi"
		str_size = (gsize) 0;
#line 2255 "serializer.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
#line 1564 "glib-2.0.vapi"
		_tmp4_ = strlen ((const gchar*) str);
#line 1564 "glib-2.0.vapi"
		_tmp5_ = _tmp4_;
#line 1564 "glib-2.0.vapi"
		str_size = (gsize) _tmp5_;
#line 2265 "serializer.c"
	}
#line 1567 "glib-2.0.vapi"
	_tmp6_ = g_malloc0 (((string_length - (end - start)) + str_size) + 1);
#line 1567 "glib-2.0.vapi"
	_result_ = _tmp6_;
#line 1569 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1569 "glib-2.0.vapi"
	dest = (gchar*) _tmp7_;
#line 1571 "glib-2.0.vapi"
	_tmp8_ = dest;
#line 1571 "glib-2.0.vapi"
	memcpy (_tmp8_, self, (gsize) start);
#line 1572 "glib-2.0.vapi"
	_tmp9_ = dest;
#line 1572 "glib-2.0.vapi"
	dest = _tmp9_ + start;
#line 1574 "glib-2.0.vapi"
	if (str != NULL) {
#line 2285 "serializer.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1575 "glib-2.0.vapi"
		_tmp10_ = dest;
#line 1575 "glib-2.0.vapi"
		memcpy (_tmp10_, str, str_size);
#line 1576 "glib-2.0.vapi"
		_tmp11_ = dest;
#line 1576 "glib-2.0.vapi"
		dest = _tmp11_ + str_size;
#line 2296 "serializer.c"
	}
#line 1579 "glib-2.0.vapi"
	_tmp12_ = dest;
#line 1579 "glib-2.0.vapi"
	memcpy (_tmp12_, ((gchar*) self) + end, (gsize) (string_length - end));
#line 1581 "glib-2.0.vapi"
	_tmp13_ = _result_;
#line 1581 "glib-2.0.vapi"
	_result_ = NULL;
#line 1581 "glib-2.0.vapi"
	result = (gchar*) _tmp13_;
#line 1581 "glib-2.0.vapi"
	return result;
#line 2310 "serializer.c"
}

static gint
serializer_cast_to_exponential_string_real (Serializer* self,
                                            Number* x,
                                            GString* string,
                                            gboolean eng_format,
                                            gint* n_digits)
{
	Number* mantissa = NULL;
	Number* _tmp0_;
	Number* base_ = NULL;
	Number* _tmp1_;
	Number* base3 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* base10 = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t = NULL;
	Number* _tmp6_;
	Number* base10inv = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	gint exponent = 0;
	Number* _tmp10_;
	gchar* mantissa_string = NULL;
	Number* _tmp42_;
	gchar* _tmp43_;
	const gchar* _tmp54_;
	gint result;
#line 454 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 454 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, 0);
#line 454 "../lib/serializer.vala"
	g_return_val_if_fail (string != NULL, 0);
#line 456 "../lib/serializer.vala"
	if (number_is_negative (x)) {
#line 457 "../lib/serializer.vala"
		g_string_append (string, "−");
#line 2353 "serializer.c"
	}
#line 459 "../lib/serializer.vala"
	_tmp0_ = number_abs (x);
#line 459 "../lib/serializer.vala"
	mantissa = _tmp0_;
#line 461 "../lib/serializer.vala"
	_tmp1_ = number_new_integer ((gint64) self->priv->number_base, (gint64) 0);
#line 461 "../lib/serializer.vala"
	base_ = _tmp1_;
#line 462 "../lib/serializer.vala"
	_tmp2_ = base_;
#line 462 "../lib/serializer.vala"
	_tmp3_ = number_xpowy_integer (_tmp2_, (gint64) 3);
#line 462 "../lib/serializer.vala"
	base3 = _tmp3_;
#line 463 "../lib/serializer.vala"
	_tmp4_ = base_;
#line 463 "../lib/serializer.vala"
	_tmp5_ = number_xpowy_integer (_tmp4_, (gint64) 10);
#line 463 "../lib/serializer.vala"
	base10 = _tmp5_;
#line 464 "../lib/serializer.vala"
	_tmp6_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 464 "../lib/serializer.vala"
	t = _tmp6_;
#line 465 "../lib/serializer.vala"
	_tmp7_ = t;
#line 465 "../lib/serializer.vala"
	_tmp8_ = base10;
#line 465 "../lib/serializer.vala"
	_tmp9_ = number_divide (_tmp7_, _tmp8_);
#line 465 "../lib/serializer.vala"
	base10inv = _tmp9_;
#line 467 "../lib/serializer.vala"
	exponent = 0;
#line 468 "../lib/serializer.vala"
	_tmp10_ = mantissa;
#line 468 "../lib/serializer.vala"
	if (!number_is_zero (_tmp10_)) {
#line 2393 "serializer.c"
		Number* _tmp34_;
#line 470 "../lib/serializer.vala"
		while (TRUE) {
#line 2397 "serializer.c"
			gboolean _tmp11_ = FALSE;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 470 "../lib/serializer.vala"
			if (!eng_format) {
#line 2404 "serializer.c"
				Number* _tmp12_;
				Number* _tmp13_;
#line 470 "../lib/serializer.vala"
				_tmp12_ = mantissa;
#line 470 "../lib/serializer.vala"
				_tmp13_ = base10;
#line 470 "../lib/serializer.vala"
				_tmp11_ = number_compare (_tmp12_, _tmp13_) >= 0;
#line 2413 "serializer.c"
			} else {
#line 470 "../lib/serializer.vala"
				_tmp11_ = FALSE;
#line 2417 "serializer.c"
			}
#line 470 "../lib/serializer.vala"
			if (!_tmp11_) {
#line 470 "../lib/serializer.vala"
				break;
#line 2423 "serializer.c"
			}
#line 472 "../lib/serializer.vala"
			exponent += 10;
#line 473 "../lib/serializer.vala"
			_tmp14_ = mantissa;
#line 473 "../lib/serializer.vala"
			_tmp15_ = base10inv;
#line 473 "../lib/serializer.vala"
			_tmp16_ = number_multiply (_tmp14_, _tmp15_);
#line 473 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 473 "../lib/serializer.vala"
			mantissa = _tmp16_;
#line 2437 "serializer.c"
		}
#line 476 "../lib/serializer.vala"
		while (TRUE) {
#line 2441 "serializer.c"
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			Number* _tmp25_;
			Number* _tmp26_;
			Number* _tmp27_;
#line 476 "../lib/serializer.vala"
			if (!eng_format) {
#line 2449 "serializer.c"
				Number* _tmp19_;
				Number* _tmp20_;
#line 476 "../lib/serializer.vala"
				_tmp19_ = mantissa;
#line 476 "../lib/serializer.vala"
				_tmp20_ = base_;
#line 476 "../lib/serializer.vala"
				_tmp18_ = number_compare (_tmp19_, _tmp20_) >= 0;
#line 2458 "serializer.c"
			} else {
#line 476 "../lib/serializer.vala"
				_tmp18_ = FALSE;
#line 2462 "serializer.c"
			}
#line 476 "../lib/serializer.vala"
			if (_tmp18_) {
#line 476 "../lib/serializer.vala"
				_tmp17_ = TRUE;
#line 2468 "serializer.c"
			} else {
				gboolean _tmp21_ = FALSE;
#line 477 "../lib/serializer.vala"
				if (eng_format) {
#line 2473 "serializer.c"
					gboolean _tmp22_ = FALSE;
					Number* _tmp23_;
					Number* _tmp24_;
#line 477 "../lib/serializer.vala"
					_tmp23_ = mantissa;
#line 477 "../lib/serializer.vala"
					_tmp24_ = base3;
#line 477 "../lib/serializer.vala"
					if (number_compare (_tmp23_, _tmp24_) >= 0) {
#line 477 "../lib/serializer.vala"
						_tmp22_ = TRUE;
#line 2485 "serializer.c"
					} else {
#line 477 "../lib/serializer.vala"
						_tmp22_ = (exponent % 3) != 0;
#line 2489 "serializer.c"
					}
#line 477 "../lib/serializer.vala"
					_tmp21_ = _tmp22_;
#line 2493 "serializer.c"
				} else {
#line 477 "../lib/serializer.vala"
					_tmp21_ = FALSE;
#line 2497 "serializer.c"
				}
#line 477 "../lib/serializer.vala"
				_tmp17_ = _tmp21_;
#line 2501 "serializer.c"
			}
#line 476 "../lib/serializer.vala"
			if (!_tmp17_) {
#line 476 "../lib/serializer.vala"
				break;
#line 2507 "serializer.c"
			}
#line 479 "../lib/serializer.vala"
			exponent += 1;
#line 480 "../lib/serializer.vala"
			_tmp25_ = mantissa;
#line 480 "../lib/serializer.vala"
			_tmp26_ = base_;
#line 480 "../lib/serializer.vala"
			_tmp27_ = number_divide (_tmp25_, _tmp26_);
#line 480 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 480 "../lib/serializer.vala"
			mantissa = _tmp27_;
#line 2521 "serializer.c"
		}
#line 483 "../lib/serializer.vala"
		while (TRUE) {
#line 2525 "serializer.c"
			gboolean _tmp28_ = FALSE;
			Number* _tmp31_;
			Number* _tmp32_;
			Number* _tmp33_;
#line 483 "../lib/serializer.vala"
			if (!eng_format) {
#line 2532 "serializer.c"
				Number* _tmp29_;
				Number* _tmp30_;
#line 483 "../lib/serializer.vala"
				_tmp29_ = mantissa;
#line 483 "../lib/serializer.vala"
				_tmp30_ = base10inv;
#line 483 "../lib/serializer.vala"
				_tmp28_ = number_compare (_tmp29_, _tmp30_) < 0;
#line 2541 "serializer.c"
			} else {
#line 483 "../lib/serializer.vala"
				_tmp28_ = FALSE;
#line 2545 "serializer.c"
			}
#line 483 "../lib/serializer.vala"
			if (!_tmp28_) {
#line 483 "../lib/serializer.vala"
				break;
#line 2551 "serializer.c"
			}
#line 485 "../lib/serializer.vala"
			exponent -= 10;
#line 486 "../lib/serializer.vala"
			_tmp31_ = mantissa;
#line 486 "../lib/serializer.vala"
			_tmp32_ = base10;
#line 486 "../lib/serializer.vala"
			_tmp33_ = number_multiply (_tmp31_, _tmp32_);
#line 486 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 486 "../lib/serializer.vala"
			mantissa = _tmp33_;
#line 2565 "serializer.c"
		}
#line 489 "../lib/serializer.vala"
		_tmp34_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 489 "../lib/serializer.vala"
		_g_object_unref0 (t);
#line 489 "../lib/serializer.vala"
		t = _tmp34_;
#line 490 "../lib/serializer.vala"
		while (TRUE) {
#line 2575 "serializer.c"
			gboolean _tmp35_ = FALSE;
			Number* _tmp36_;
			Number* _tmp37_;
			Number* _tmp39_;
			Number* _tmp40_;
			Number* _tmp41_;
#line 490 "../lib/serializer.vala"
			_tmp36_ = mantissa;
#line 490 "../lib/serializer.vala"
			_tmp37_ = t;
#line 490 "../lib/serializer.vala"
			if (number_compare (_tmp36_, _tmp37_) < 0) {
#line 490 "../lib/serializer.vala"
				_tmp35_ = TRUE;
#line 2590 "serializer.c"
			} else {
				gboolean _tmp38_ = FALSE;
#line 490 "../lib/serializer.vala"
				if (eng_format) {
#line 490 "../lib/serializer.vala"
					_tmp38_ = (exponent % 3) != 0;
#line 2597 "serializer.c"
				} else {
#line 490 "../lib/serializer.vala"
					_tmp38_ = FALSE;
#line 2601 "serializer.c"
				}
#line 490 "../lib/serializer.vala"
				_tmp35_ = _tmp38_;
#line 2605 "serializer.c"
			}
#line 490 "../lib/serializer.vala"
			if (!_tmp35_) {
#line 490 "../lib/serializer.vala"
				break;
#line 2611 "serializer.c"
			}
#line 492 "../lib/serializer.vala"
			exponent -= 1;
#line 493 "../lib/serializer.vala"
			_tmp39_ = mantissa;
#line 493 "../lib/serializer.vala"
			_tmp40_ = base_;
#line 493 "../lib/serializer.vala"
			_tmp41_ = number_multiply (_tmp39_, _tmp40_);
#line 493 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 493 "../lib/serializer.vala"
			mantissa = _tmp41_;
#line 2625 "serializer.c"
		}
	}
#line 497 "../lib/serializer.vala"
	_tmp42_ = mantissa;
#line 497 "../lib/serializer.vala"
	_tmp43_ = serializer_cast_to_string (self, _tmp42_, n_digits);
#line 497 "../lib/serializer.vala"
	mantissa_string = _tmp43_;
#line 498 "../lib/serializer.vala"
	if (eng_format) {
#line 2636 "serializer.c"
		const gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		const gchar* _tmp48_;
#line 500 "../lib/serializer.vala"
		_tmp44_ = mantissa_string;
#line 500 "../lib/serializer.vala"
		_tmp45_ = g_unichar_to_string (self->priv->tsep);
#line 500 "../lib/serializer.vala"
		_tmp46_ = _tmp45_;
#line 500 "../lib/serializer.vala"
		_tmp47_ = string_replace (_tmp44_, _tmp46_, "");
#line 500 "../lib/serializer.vala"
		_g_free0 (mantissa_string);
#line 500 "../lib/serializer.vala"
		mantissa_string = _tmp47_;
#line 500 "../lib/serializer.vala"
		_g_free0 (_tmp46_);
#line 501 "../lib/serializer.vala"
		_tmp48_ = mantissa_string;
#line 501 "../lib/serializer.vala"
		if (g_str_has_prefix (_tmp48_, "1000")) {
#line 2660 "serializer.c"
			const gchar* _tmp49_;
			gchar* _tmp50_;
#line 503 "../lib/serializer.vala"
			exponent += 3;
#line 504 "../lib/serializer.vala"
			_tmp49_ = mantissa_string;
#line 504 "../lib/serializer.vala"
			_tmp50_ = string_splice (_tmp49_, (glong) 0, (glong) 4, "1");
#line 504 "../lib/serializer.vala"
			_g_free0 (mantissa_string);
#line 504 "../lib/serializer.vala"
			mantissa_string = _tmp50_;
#line 505 "../lib/serializer.vala"
			*n_digits = 1;
#line 2675 "serializer.c"
		}
	} else {
		const gchar* _tmp51_;
#line 508 "../lib/serializer.vala"
		_tmp51_ = mantissa_string;
#line 508 "../lib/serializer.vala"
		if (g_str_has_prefix (_tmp51_, "10")) {
#line 2683 "serializer.c"
			const gchar* _tmp52_;
			gchar* _tmp53_;
#line 510 "../lib/serializer.vala"
			exponent += 1;
#line 511 "../lib/serializer.vala"
			_tmp52_ = mantissa_string;
#line 511 "../lib/serializer.vala"
			_tmp53_ = string_splice (_tmp52_, (glong) 0, (glong) 2, "1");
#line 511 "../lib/serializer.vala"
			_g_free0 (mantissa_string);
#line 511 "../lib/serializer.vala"
			mantissa_string = _tmp53_;
#line 512 "../lib/serializer.vala"
			*n_digits = 1;
#line 2698 "serializer.c"
		}
	}
#line 514 "../lib/serializer.vala"
	_tmp54_ = mantissa_string;
#line 514 "../lib/serializer.vala"
	g_string_append (string, _tmp54_);
#line 516 "../lib/serializer.vala"
	result = exponent;
#line 516 "../lib/serializer.vala"
	_g_free0 (mantissa_string);
#line 516 "../lib/serializer.vala"
	_g_object_unref0 (base10inv);
#line 516 "../lib/serializer.vala"
	_g_object_unref0 (t);
#line 516 "../lib/serializer.vala"
	_g_object_unref0 (base10);
#line 516 "../lib/serializer.vala"
	_g_object_unref0 (base3);
#line 516 "../lib/serializer.vala"
	_g_object_unref0 (base_);
#line 516 "../lib/serializer.vala"
	_g_object_unref0 (mantissa);
#line 516 "../lib/serializer.vala"
	return result;
#line 2723 "serializer.c"
}

static gchar*
serializer_cast_to_exponential_string (Serializer* self,
                                       Number* x,
                                       gboolean eng_format,
                                       gint* n_digits)
{
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	gint exponent = 0;
	Number* _tmp2_;
	GString* _tmp3_;
	gint _tmp4_;
	GString* _tmp5_;
	GString* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* result;
#line 519 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 519 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 521 "../lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 521 "../lib/serializer.vala"
	string = _tmp0_;
#line 523 "../lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 523 "../lib/serializer.vala"
	x_real = _tmp1_;
#line 524 "../lib/serializer.vala"
	_tmp2_ = x_real;
#line 524 "../lib/serializer.vala"
	_tmp3_ = string;
#line 524 "../lib/serializer.vala"
	_tmp4_ = serializer_cast_to_exponential_string_real (self, _tmp2_, _tmp3_, eng_format, n_digits);
#line 524 "../lib/serializer.vala"
	exponent = _tmp4_;
#line 525 "../lib/serializer.vala"
	_tmp5_ = string;
#line 525 "../lib/serializer.vala"
	serializer_append_exponent (self, _tmp5_, exponent);
#line 527 "../lib/serializer.vala"
	if (number_is_complex (x)) {
#line 2771 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp6_;
		GString* _tmp7_;
		const gchar* _tmp8_;
		GString* s = NULL;
		GString* _tmp10_;
		gint n_complex_digits = 0;
		Number* _tmp11_;
		GString* _tmp12_;
		gint _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GString* _tmp16_;
		const gchar* _tmp17_;
		GString* _tmp40_;
#line 529 "../lib/serializer.vala"
		_tmp6_ = number_imaginary_component (x);
#line 529 "../lib/serializer.vala"
		x_im = _tmp6_;
#line 531 "../lib/serializer.vala"
		_tmp7_ = string;
#line 531 "../lib/serializer.vala"
		_tmp8_ = _tmp7_->str;
#line 531 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp8_, "0") == 0) {
#line 2797 "serializer.c"
			GString* _tmp9_;
#line 532 "../lib/serializer.vala"
			_tmp9_ = string;
#line 532 "../lib/serializer.vala"
			g_string_assign (_tmp9_, "");
#line 2803 "serializer.c"
		}
#line 534 "../lib/serializer.vala"
		_tmp10_ = g_string_sized_new ((gsize) 1024);
#line 534 "../lib/serializer.vala"
		s = _tmp10_;
#line 535 "../lib/serializer.vala"
		n_complex_digits = 0;
#line 536 "../lib/serializer.vala"
		_tmp11_ = x_im;
#line 536 "../lib/serializer.vala"
		_tmp12_ = s;
#line 536 "../lib/serializer.vala"
		_tmp13_ = serializer_cast_to_exponential_string_real (self, _tmp11_, _tmp12_, eng_format, &n_complex_digits);
#line 536 "../lib/serializer.vala"
		exponent = _tmp13_;
#line 537 "../lib/serializer.vala"
		if (n_complex_digits > (*n_digits)) {
#line 538 "../lib/serializer.vala"
			*n_digits = n_complex_digits;
#line 2823 "serializer.c"
		}
#line 539 "../lib/serializer.vala"
		_tmp16_ = s;
#line 539 "../lib/serializer.vala"
		_tmp17_ = _tmp16_->str;
#line 539 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp17_, "0") == 0) {
#line 539 "../lib/serializer.vala"
			_tmp15_ = TRUE;
#line 2833 "serializer.c"
		} else {
			GString* _tmp18_;
			const gchar* _tmp19_;
#line 539 "../lib/serializer.vala"
			_tmp18_ = s;
#line 539 "../lib/serializer.vala"
			_tmp19_ = _tmp18_->str;
#line 539 "../lib/serializer.vala"
			_tmp15_ = g_strcmp0 (_tmp19_, "+0") == 0;
#line 2843 "serializer.c"
		}
#line 539 "../lib/serializer.vala"
		if (_tmp15_) {
#line 539 "../lib/serializer.vala"
			_tmp14_ = TRUE;
#line 2849 "serializer.c"
		} else {
			GString* _tmp20_;
			const gchar* _tmp21_;
#line 539 "../lib/serializer.vala"
			_tmp20_ = s;
#line 539 "../lib/serializer.vala"
			_tmp21_ = _tmp20_->str;
#line 539 "../lib/serializer.vala"
			_tmp14_ = g_strcmp0 (_tmp21_, "−0") == 0;
#line 2859 "serializer.c"
		}
#line 539 "../lib/serializer.vala"
		if (_tmp14_) {
#line 2863 "serializer.c"
		} else {
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 543 "../lib/serializer.vala"
			_tmp22_ = s;
#line 543 "../lib/serializer.vala"
			_tmp23_ = _tmp22_->str;
#line 543 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp23_, "1") == 0) {
#line 2873 "serializer.c"
				GString* _tmp24_;
#line 545 "../lib/serializer.vala"
				_tmp24_ = string;
#line 545 "../lib/serializer.vala"
				g_string_append (_tmp24_, "i");
#line 2879 "serializer.c"
			} else {
				GString* _tmp25_;
				const gchar* _tmp26_;
#line 547 "../lib/serializer.vala"
				_tmp25_ = s;
#line 547 "../lib/serializer.vala"
				_tmp26_ = _tmp25_->str;
#line 547 "../lib/serializer.vala"
				if (g_strcmp0 (_tmp26_, "+1") == 0) {
#line 2889 "serializer.c"
					GString* _tmp27_;
#line 549 "../lib/serializer.vala"
					_tmp27_ = string;
#line 549 "../lib/serializer.vala"
					g_string_append (_tmp27_, "+i");
#line 2895 "serializer.c"
				} else {
					GString* _tmp28_;
					const gchar* _tmp29_;
#line 551 "../lib/serializer.vala"
					_tmp28_ = s;
#line 551 "../lib/serializer.vala"
					_tmp29_ = _tmp28_->str;
#line 551 "../lib/serializer.vala"
					if (g_strcmp0 (_tmp29_, "−1") == 0) {
#line 2905 "serializer.c"
						GString* _tmp30_;
#line 553 "../lib/serializer.vala"
						_tmp30_ = string;
#line 553 "../lib/serializer.vala"
						g_string_append (_tmp30_, "−i");
#line 2911 "serializer.c"
					} else {
						GString* _tmp31_;
						const gchar* _tmp32_;
						GString* _tmp39_;
#line 557 "../lib/serializer.vala"
						_tmp31_ = s;
#line 557 "../lib/serializer.vala"
						_tmp32_ = _tmp31_->str;
#line 557 "../lib/serializer.vala"
						if (g_strcmp0 (_tmp32_, "+0") == 0) {
#line 2922 "serializer.c"
							GString* _tmp33_;
#line 558 "../lib/serializer.vala"
							_tmp33_ = string;
#line 558 "../lib/serializer.vala"
							g_string_append (_tmp33_, "+");
#line 2928 "serializer.c"
						} else {
							GString* _tmp34_;
							const gchar* _tmp35_;
#line 559 "../lib/serializer.vala"
							_tmp34_ = s;
#line 559 "../lib/serializer.vala"
							_tmp35_ = _tmp34_->str;
#line 559 "../lib/serializer.vala"
							if (g_strcmp0 (_tmp35_, "0") != 0) {
#line 2938 "serializer.c"
								GString* _tmp36_;
								GString* _tmp37_;
								const gchar* _tmp38_;
#line 560 "../lib/serializer.vala"
								_tmp36_ = string;
#line 560 "../lib/serializer.vala"
								_tmp37_ = s;
#line 560 "../lib/serializer.vala"
								_tmp38_ = _tmp37_->str;
#line 560 "../lib/serializer.vala"
								g_string_append (_tmp36_, _tmp38_);
#line 2950 "serializer.c"
							}
						}
#line 562 "../lib/serializer.vala"
						_tmp39_ = string;
#line 562 "../lib/serializer.vala"
						g_string_append (_tmp39_, "i");
#line 2957 "serializer.c"
					}
				}
			}
		}
#line 564 "../lib/serializer.vala"
		_tmp40_ = string;
#line 564 "../lib/serializer.vala"
		serializer_append_exponent (self, _tmp40_, exponent);
#line 527 "../lib/serializer.vala"
		_g_string_free0 (s);
#line 527 "../lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 2970 "serializer.c"
	}
#line 567 "../lib/serializer.vala"
	_tmp41_ = string;
#line 567 "../lib/serializer.vala"
	_tmp42_ = _tmp41_->str;
#line 567 "../lib/serializer.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 567 "../lib/serializer.vala"
	result = _tmp43_;
#line 567 "../lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 567 "../lib/serializer.vala"
	_g_string_free0 (string);
#line 567 "../lib/serializer.vala"
	return result;
#line 2986 "serializer.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 3003 "serializer.c"
}

static void
serializer_append_exponent (Serializer* self,
                            GString* string,
                            gint exponent)
{
#line 572 "../lib/serializer.vala"
	static const gunichar super_digits[10] = {8304U, 185U, 178U, 179U, 8308U, 8309U, 8310U, 8311U, 8312U, 8313U};
#line 3013 "serializer.c"
	gchar* super_value = NULL;
	gchar* _tmp0_;
#line 570 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 570 "../lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 574 "../lib/serializer.vala"
	if (exponent == 0) {
#line 575 "../lib/serializer.vala"
		return;
#line 3024 "serializer.c"
	}
#line 577 "../lib/serializer.vala"
	g_string_append (string, "×10");
#line 578 "../lib/serializer.vala"
	if (exponent < 0) {
#line 580 "../lib/serializer.vala"
		exponent = -exponent;
#line 581 "../lib/serializer.vala"
		g_string_append_unichar (string, 8315U);
#line 3034 "serializer.c"
	}
#line 584 "../lib/serializer.vala"
	_tmp0_ = g_strdup_printf ("%d", exponent);
#line 584 "../lib/serializer.vala"
	super_value = _tmp0_;
#line 3040 "serializer.c"
	{
		gint i = 0;
#line 585 "../lib/serializer.vala"
		i = 0;
#line 3045 "serializer.c"
		{
			gboolean _tmp1_ = FALSE;
#line 585 "../lib/serializer.vala"
			_tmp1_ = TRUE;
#line 585 "../lib/serializer.vala"
			while (TRUE) {
#line 3052 "serializer.c"
				const gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				const gchar* _tmp6_;
				gunichar _tmp7_;
#line 585 "../lib/serializer.vala"
				if (!_tmp1_) {
#line 3060 "serializer.c"
					gint _tmp2_;
#line 585 "../lib/serializer.vala"
					_tmp2_ = i;
#line 585 "../lib/serializer.vala"
					i = _tmp2_ + 1;
#line 3066 "serializer.c"
				}
#line 585 "../lib/serializer.vala"
				_tmp1_ = FALSE;
#line 585 "../lib/serializer.vala"
				_tmp3_ = super_value;
#line 585 "../lib/serializer.vala"
				_tmp4_ = strlen (_tmp3_);
#line 585 "../lib/serializer.vala"
				_tmp5_ = _tmp4_;
#line 585 "../lib/serializer.vala"
				if (!(i < _tmp5_)) {
#line 585 "../lib/serializer.vala"
					break;
#line 3080 "serializer.c"
				}
#line 586 "../lib/serializer.vala"
				_tmp6_ = super_value;
#line 586 "../lib/serializer.vala"
				_tmp7_ = super_digits[string_get (_tmp6_, (glong) i) - '0'];
#line 586 "../lib/serializer.vala"
				g_string_append_unichar (string, _tmp7_);
#line 3088 "serializer.c"
			}
		}
	}
#line 570 "../lib/serializer.vala"
	_g_free0 (super_value);
#line 3094 "serializer.c"
}

const gchar*
serializer_get_error (Serializer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../lib/serializer.vala"
	_tmp0_ = self->priv->_error;
#line 37 "../lib/serializer.vala"
	result = _tmp0_;
#line 37 "../lib/serializer.vala"
	return result;
#line 3110 "serializer.c"
}

void
serializer_set_error (Serializer* self,
                      const gchar* value)
{
	gchar* old_value;
#line 37 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/serializer.vala"
	old_value = serializer_get_error (self);
#line 37 "../lib/serializer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3124 "serializer.c"
		gchar* _tmp0_;
#line 37 "../lib/serializer.vala"
		_tmp0_ = g_strdup (value);
#line 37 "../lib/serializer.vala"
		_g_free0 (self->priv->_error);
#line 37 "../lib/serializer.vala"
		self->priv->_error = _tmp0_;
#line 37 "../lib/serializer.vala"
		g_object_notify_by_pspec ((GObject *) self, serializer_properties[SERIALIZER_ERROR_PROPERTY]);
#line 3134 "serializer.c"
	}
}

static void
serializer_class_init (SerializerClass * klass,
                       gpointer klass_data)
{
#line 20 "../lib/serializer.vala"
	serializer_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/serializer.vala"
	g_type_class_adjust_private_offset (klass, &Serializer_private_offset);
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_serializer_get_property;
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_serializer_set_property;
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->finalize = serializer_finalize;
#line 20 "../lib/serializer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERIALIZER_ERROR_PROPERTY, serializer_properties[SERIALIZER_ERROR_PROPERTY] = g_param_spec_string ("error", "error", "error", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3154 "serializer.c"
}

static void
serializer_instance_init (Serializer * self,
                          gpointer klass)
{
#line 20 "../lib/serializer.vala"
	self->priv = serializer_get_instance_private (self);
#line 37 "../lib/serializer.vala"
	self->priv->_error = NULL;
#line 3165 "serializer.c"
}

static void
serializer_finalize (GObject * obj)
{
	Serializer * self;
#line 20 "../lib/serializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERIALIZER, Serializer);
#line 34 "../lib/serializer.vala"
	_g_free0 (self->priv->zero_string);
#line 37 "../lib/serializer.vala"
	_g_free0 (self->priv->_error);
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (serializer_parent_class)->finalize (obj);
#line 3180 "serializer.c"
}

static GType
serializer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SerializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) serializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Serializer), 0, (GInstanceInitFunc) serializer_instance_init, NULL };
	GType serializer_type_id;
	serializer_type_id = g_type_register_static (G_TYPE_OBJECT, "Serializer", &g_define_type_info, 0);
	Serializer_private_offset = g_type_add_instance_private (serializer_type_id, sizeof (SerializerPrivate));
	return serializer_type_id;
}

GType
serializer_get_type (void)
{
	static volatile gsize serializer_type_id__once = 0;
	if (g_once_init_enter (&serializer_type_id__once)) {
		GType serializer_type_id;
		serializer_type_id = serializer_get_type_once ();
		g_once_init_leave (&serializer_type_id__once, serializer_type_id);
	}
	return serializer_type_id__once;
}

static void
_vala_serializer_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "../lib/serializer.vala"
	switch (property_id) {
#line 20 "../lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "../lib/serializer.vala"
		g_value_set_string (value, serializer_get_error (self));
#line 20 "../lib/serializer.vala"
		break;
#line 3221 "serializer.c"
		default:
#line 20 "../lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/serializer.vala"
		break;
#line 3227 "serializer.c"
	}
}

static void
_vala_serializer_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "../lib/serializer.vala"
	switch (property_id) {
#line 20 "../lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "../lib/serializer.vala"
		serializer_set_error (self, g_value_get_string (value));
#line 20 "../lib/serializer.vala"
		break;
#line 3247 "serializer.c"
		default:
#line 20 "../lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/serializer.vala"
		break;
#line 3253 "serializer.c"
	}
}

